' PwKeeper - a tray-located password (whatever) keeper
' Public Domain by Borje Hagsten, October 2002
' Compiled with PB/WIN 7.0, but should work with PB/DLL 5/6.x too.
'
' Copy this code, paste into your editor, change $TEXTBOXTEXT to
' contain your name and forum password, then compile and run.
' -------------------------------------------------------------------
' Sometimes I need to look up Forum password because browser/cookie
' has lost it. To make life easier, I wrote this little program that
' stores whatever I need in a textbox.
'
' Prog is using %WS_EX_TOOLWINDOW style to keep it from showing up in
' taskbar. It's initially hidden, without any flicker. Probably I
' have done something right..
'
' Have lookad at other samples here, but none of them handled hidden
' load the way I wanted. Seems using dialogs is not a good option,
' since dialogs can't have toolwindow style (I think)? SDK-style
' creation works perfect, so have used this way.
'
' COMMENTS: Since I always have to complicate things, I have used an
' ownerdrawn top menu item here, so it looks like the right-click
' popup menu has a caption. You can experiment there with drawing
' a bitmap or icon, etc. See WM_DRAWITEM. It also considers tray's
' position on screen and places prog near it for easy access/close.
' And since I'm too lazy to double-click, I have let it respond to
' WM_LBUTTONDOWN. Change to WM_LBUTTONDBLCLK if you like. I have used
' simple system icon here - add/load own from resource file if you like.
'
' TIP: I have placed the program in my AutoStart folder, so it loads
' straight into the Tray at start-up. Is very handy to have it there..
'
' IDEA: Can add a listbox to it and store more things you sometimes
' need to access. And/or add shortcuts to programs/websites, whatever..
'
#COMPILE EXE
#INCLUDE "WIN32API.INC"
'----------------------------
$TEXTBOXTEXT = "Bill Gates Password" 'name + password for easy copying
'----------------------------
%WM_TRAYICON = %WM_USER + 400
%IDC_EDIT    = %WM_USER + 420
%IDC_BTNCOPY = %WM_USER + 422
%IDM_CAPTION = %WM_USER + 440
%IDM_EXIT    = %WM_USER + 442
'----------------------------
GLOBAL hAccel AS DWORD, hInst AS DWORD, _
       hFontCaption AS DWORD, hFontEdit AS DWORD, hFontButton AS DWORD

'
' Main entrance
'
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, _
                  BYVAL lpCmdLine AS ASCIIZ PTR, BYVAL iCmdShow AS LONG) AS LONG

  LOCAL hWnd AS DWORD, hCopy AS DWORD, hButn AS DWORD, hEdit AS DWORD, _
        ctlHeight AS LONG, dlgHeight AS LONG, Msg AS TAGMSG, _
        ncm AS NONCLIENTMETRICS, wc AS WNDCLASSEX, szString AS ASCIIZ * 200

  szString = "PwKeeper"
  IF FINDWINDOW(szString, "") <> 0 THEN EXIT FUNCTION 'Prevent duplicate instances

   hInst      = hInstance   'store instance handle in global variable for later use
  ncm.cbSize = SIZEOF(ncm) 'grab some font data for use in controls
  SYSTEMPARAMETERSINFO %SPI_GETNONCLIENTMETRICS, SIZEOF(ncm), BYVAL VARPTR(ncm), 0
  hFontCaption = CREATEFONTINDIRECT(ncm.lfCaptionFont)
  hFontEdit    = CREATEFONTINDIRECT(ncm.lfMenuFont)
  hFontButton  = CREATEFONTINDIRECT(ncm.lfStatusFont)
  ctlHeight    = ncm.iMenuHeight + 5
  dlgHeight    = ncm.iSmCaptionHeight + (2 * ctlHeight) + 30

  wc.cbSize        = SIZEOF(wc)
  wc.lpfnWndProc   = CODEPTR(WndProc)
  wc.hCursor       = LOADCURSOR(%NULL, BYVAL %IDC_ARROW)
  wc.hInstance     = hInst
  wc.lpszClassName = VARPTR(szString)
  wc.hbrBackground = %COLOR_APPWORKSPACE + 1
  REGISTERCLASSEX wc

  'Create main window
  hWnd  = CREATEWINDOWEX(%WS_EX_TOOLWINDOW OR %WS_EX_TOPMOST, szString, _
                         "PwKeeper v1.0", %WS_CAPTION OR %WS_SYSMENU, _
                         0, 0, 200, dlgHeight, 0, 0, hInst, BYVAL 0&)

  'Create child controls
  hEdit = CREATEWINDOWEX(%WS_EX_CLIENTEDGE, "EDIT", "", %WS_CHILD OR %WS_VISIBLE OR _
                         %ES_CENTER OR %ES_NOHIDESEL OR %ES_AUTOHSCROLL, _
                         8, 8, 180, ctlHeight, hWnd, %IDC_EDIT, hInst, BYVAL 0&)

  hCopy = CREATEWINDOWEX(0, "BUTTON", "Copy", _
                         %BS_PUSHBUTTON OR %WS_CHILD OR %WS_VISIBLE, _
                         8, ctlHeight + 17, 80, ctlHeight, hWnd, %IDC_BTNCOPY, hInst, BYVAL 0&)

  hButn = CREATEWINDOWEX(0, "BUTTON", "Cancel", _
                         %BS_PUSHBUTTON OR %WS_CHILD OR %WS_VISIBLE, _
                         108, ctlHeight + 17, 80, ctlHeight, hWnd, %IDCANCEL, hInst, BYVAL 0&)

  IF hFontEdit   THEN SENDMESSAGE hEdit, %WM_SETFONT, hFontEdit, 0
  IF hFontButton THEN
     SENDMESSAGE hCopy, %WM_SETFONT, hFontButton, 0
     SENDMESSAGE hButn, %WM_SETFONT, hFontButton, 0
  END IF

  REDIM ac(0) AS ACCELAPI 'Create an accelerator table for Escape key
  ac(0).fVirt = %FVIRTKEY
  ac(0).key   = %VK_ESCAPE
  ac(0).cmd   = %IDCANCEL  'Escape key will trigger %IDCANCEL
  hAccel = CREATEACCELERATORTABLE(ac(0), 1)

  WHILE GETMESSAGE(Msg, %NULL, 0, 0)
     IF ISFALSE TRANSLATEACCELERATOR(hwnd, hAccel, Msg) THEN
        TRANSLATEMESSAGE Msg
        DISPATCHMESSAGE Msg
     END IF
  WEND
END FUNCTION

'
' Message handler
'
FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                  BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

  LOCAL pt AS POINTAPI, rc AS RECT, rcDesktop AS RECT, zTxt AS ASCIIZ * 100
  STATIC ti AS NOTIFYICONDATA

  SELECT CASE wMsg
     CASE %WM_CREATE 'sent by CreateWindowEx, when Main window is created
        ti.cbSize           = SIZEOF(ti) 'fill structure with proper data
        ti.hWnd             = hWnd
        ti.uID              = hInst
        ti.uFlags           = %NIF_ICON OR %NIF_MESSAGE OR %NIF_TIP
        ti.uCallbackMessage = %WM_TRAYICON
        ti.hIcon            = LOADICON(0, BYVAL %IDI_QUESTION) 'or own icon..
        ti.szTip            = " PwKeeper "
        SHELL_NOTIFYICON %NIM_ADD, ti 'add icon to Tray

        'DestroyIcon ti.hIcon   'if icon is loaded from resource or file..
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_TRAYICON
        SELECT CASE LOWRD(lParam)
          CASE %WM_LBUTTONDOWN 'show window - consider Tray's location
             IF ISWINDOWVISIBLE(hWnd) = %FALSE THEN
                GETCURSORPOS pt                       'cursor position on screen
                SYSTEMPARAMETERSINFO %SPI_GETWORKAREA, 0, BYVAL VARPTR(rcDesktop), 0 'desktop's size
                GETWINDOWRECT hWnd, rc                'for this window's full size
                rc.nRight  = (rc.nRight - rc.nLeft)   'calculate this window's full width
                rc.nBottom = (rc.nBottom - rc.nTop)   'and full height

                IF pt.y > rcDesktop.nBottom / 2 THEN     'if tray is at bottom of screen (default)
                   pt.y = rcDesktop.nBottom - rc.nBottom 'determine program's top position
                ELSE
                   pt.y = rcDesktop.nTop
                END IF
                IF pt.x > rcDesktop.nRight / 2 THEN    'if tray is on right side of screen (default)
                   pt.x = rcDesktop.nRight - rc.nRight 'determine program's left position
                ELSE
                   pt.x = rcDesktop.nLeft
                END IF

                SETFOREGROUNDWINDOW hWnd  'set program to foreground and activate, then set pos and show
                SETWINDOWPOS hWnd, 0, pt.x, pt.y, 0, 0, %SWP_NOSIZE OR %SWP_NOZORDER OR %SWP_SHOWWINDOW
                SETWINDOWTEXT GETDLGITEM(hWnd, %IDC_EDIT), $TEXTBOXTEXT    'set desired text
                SENDMESSAGE GETDLGITEM(hWnd, %IDC_EDIT), %EM_SETSEL, 0, -1 'select all text
                SETFOCUS GETDLGITEM(hWnd, %IDC_EDIT)                       'and give textbox focus
                FUNCTION = 0 : EXIT FUNCTION
             END IF

           CASE %WM_RBUTTONDOWN 'create and show popup menu
              'Note: top item is ownerdrawn, used as "caption". See WM_DRAWITEM.
              IF ISWINDOWVISIBLE(hWnd) = %FALSE THEN
                 LOCAL hMenu AS DWORD
                 GETCURSORPOS pt
                 SETFOREGROUNDWINDOW hWnd
                 hmenu = CREATEPOPUPMENU
                 APPENDMENU hMenu, %MF_STRING OR %MF_ENABLED OR %MF_OWNERDRAW, %IDM_CAPTION, ""
                 APPENDMENU hMenu, %MF_STRING OR %MF_ENABLED, %IDM_EXIT, "&Remove from Tray"

                 TRACKPOPUPMENU hMenu, %TPM_CENTERALIGN, pt.x, pt.y, 0, hWnd, BYVAL %NULL
                 POSTMESSAGE hWnd, %WM_NULL, 0, 0
                 DESTROYMENU hMenu 'clean up by destroying what we have created
                 FUNCTION = 0 : EXIT FUNCTION
              END IF
        END SELECT

     CASE %WM_DRAWITEM 'draw ownerdrawn top menu item. Experiment if you like..
        LOCAL lpDis AS DRAWITEMSTRUCT PTR
        lpDis = lParam
        IF @lpDis.ctlType = %ODT_MENU AND @lpDis.itemID = %IDM_CAPTION THEN
           zTxt = "PwKeeper v1.0"                                   'text to draw
           hFontCaption = SELECTOBJECT(@lpDis.hDC, hFontCaption)    'use caption font
           SETBKMODE @lpDis.hDC, %TRANSPARENT                       'transparent text background
           SETTEXTCOLOR @lpDis.hDC, GETSYSCOLOR(%COLOR_CAPTIONTEXT) 'text color
           DECR @lpDis.rcItem.nBottom                               'for a thin "line" between top item and
           FILLRECT @lpDis.hDC, @lpDis.rcItem, _                    ' next item, when next item is selected
                    GETSYSCOLORBRUSH(%COLOR_ACTIVECAPTION)          'fill background color
           INCR @lpDis.rcItem.nBottom                               'restore rectangle again
           DRAWTEXT @lpDis.hDC, zTxt, LEN(zTxt), @lpDis.rcItem, _   'draw text
                    %DT_CENTER OR %DT_VCENTER OR %DT_SINGLELINE
           hFontCaption = SELECTOBJECT(@lpDis.hDC, hFontCaption)    'restore font handle
        END IF

     CASE %WM_COMMAND
        SELECT CASE LOWRD(wParam)
           CASE %IDM_EXIT 'user selected Exit from menu
             IF MESSAGEBOX(hWnd, "Terminate PwKeeper and remove its icon from the task tray?", _
                "PwKeeper", %MB_ICONQUESTION OR %MB_YESNO) = %IDYES THEN
                 SENDMESSAGE hWnd, %WM_CLOSE, 0, 0
                 FUNCTION = 0 : EXIT FUNCTION
             END IF

          CASE %IDC_BTNCOPY
             SENDMESSAGE GETDLGITEM(hWnd, %IDC_EDIT), %WM_COPY, 0, 0
             SHOWWINDOW hWnd, %SW_HIDE
             FUNCTION = 0 : EXIT FUNCTION

           CASE %IDCANCEL 'user pressed Cancel button or Escape key
              SHOWWINDOW hWnd, %SW_HIDE
              FUNCTION = 0 : EXIT FUNCTION

         END SELECT

     CASE %WM_DESTROY 'clean up at exit
        SHELL_NOTIFYICON %NIM_DELETE, ti               'remove icon from Tray
        IF hFontButton  THEN DELETEOBJECT hFontButton  'delete created fonts
        IF hFontCaption THEN DELETEOBJECT hFontCaption
        IF hFontEdit    THEN DELETEOBJECT hFontEdit
        IF hAccel THEN DESTROYACCELERATORTABLE hAccel  'delete created accelator table
        POSTQUITMESSAGE 0

     CASE %WM_SYSCOMMAND 'if user closes via x
        SELECT CASE LOWRD(wParam)
           CASE %SC_CLOSE
              SHOWWINDOW hWnd, %SW_HIDE 'hide program, instead of ending it
              FUNCTION = 1 : EXIT FUNCTION
        END SELECT

  END SELECT

  FUNCTION = DEFWINDOWPROC(hWnd, wMsg, wParam, lParam)
END FUNCTION
